VERSION 5.00
Object = "{D6CD40C0-A522-11D0-9800-D3C9B35D2C47}#1.0#0"; "spirit.ocx"
Begin VB.Form FrmSwitch 
   Caption         =   "CM to MS Switchboard"
   ClientHeight    =   4905
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4755
   LinkTopic       =   "Form1"
   ScaleHeight     =   4905
   ScaleWidth      =   4755
   StartUpPosition =   3  'Windows Default
   Begin SPIRITLib.Spirit SpiritSecundary 
      Height          =   375
      Left            =   240
      TabIndex        =   19
      Top             =   3240
      Width           =   375
      _Version        =   65536
      _ExtentX        =   661
      _ExtentY        =   661
      _StockProps     =   0
   End
   Begin VB.CommandButton CommandGetMessage 
      Caption         =   "get"
      Height          =   375
      Left            =   2520
      TabIndex        =   4
      Top             =   2640
      Width           =   375
   End
   Begin VB.Timer TimerExchange 
      Interval        =   500
      Left            =   4320
      Top             =   3480
   End
   Begin VB.CommandButton CommandExchange 
      Caption         =   "->"
      Height          =   375
      Index           =   1
      Left            =   2520
      TabIndex        =   3
      Top             =   720
      Width           =   375
   End
   Begin VB.CommandButton CommandExchange 
      Caption         =   "<-"
      Height          =   375
      Index           =   0
      Left            =   2520
      TabIndex        =   2
      Top             =   1560
      Width           =   375
   End
   Begin VB.CheckBox CheckPolling 
      Caption         =   "Continual exchange"
      Height          =   255
      Left            =   1800
      TabIndex        =   1
      Top             =   3360
      Width           =   1935
   End
   Begin VB.Frame Frame1 
      Caption         =   "Cybermaster Unit"
      Height          =   2895
      Left            =   960
      TabIndex        =   5
      Top             =   360
      Width           =   1695
      Begin VB.TextBox TextMessage 
         Height          =   285
         Index           =   0
         Left            =   360
         Locked          =   -1  'True
         TabIndex        =   10
         Top             =   2280
         Width           =   975
      End
      Begin VB.TextBox TextVar1 
         Height          =   285
         Index           =   0
         Left            =   360
         TabIndex        =   9
         Top             =   360
         Width           =   975
      End
      Begin VB.TextBox TextVar2 
         Height          =   285
         Index           =   0
         Left            =   360
         TabIndex        =   8
         Top             =   1200
         Width           =   975
      End
      Begin VB.CommandButton CommandExchange 
         Caption         =   "^"
         Height          =   375
         Index           =   2
         Left            =   600
         TabIndex        =   7
         Top             =   720
         Width           =   375
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "Mindstorms RCX"
      Height          =   2895
      Left            =   2760
      TabIndex        =   6
      Top             =   360
      Width           =   1695
      Begin VB.TextBox TextVar1 
         Height          =   285
         Index           =   1
         Left            =   360
         TabIndex        =   14
         Top             =   360
         Width           =   975
      End
      Begin VB.TextBox TextVar2 
         Height          =   285
         Index           =   1
         Left            =   360
         TabIndex        =   13
         Top             =   1200
         Width           =   975
      End
      Begin VB.CommandButton CommandExchange 
         Caption         =   "V"
         Height          =   375
         Index           =   3
         Left            =   600
         TabIndex        =   12
         Top             =   720
         Width           =   375
      End
      Begin VB.TextBox TextMessage 
         Height          =   285
         Index           =   1
         Left            =   360
         Locked          =   -1  'True
         TabIndex        =   11
         Top             =   2280
         Width           =   975
      End
   End
   Begin VB.Label Label3 
      Caption         =   "This assumes MS at COM1 and CM at COM2."
      Height          =   255
      Left            =   360
      TabIndex        =   18
      Top             =   4560
      Width           =   4215
   End
   Begin VB.Line Line1 
      X1              =   360
      X2              =   4440
      Y1              =   3720
      Y2              =   3720
   End
   Begin VB.Label LabelHint 
      Caption         =   "This switchboard can be used to exchange messages between Cybermaster and Mindstorms units. The computer acts as an intermediary."
      Height          =   615
      Left            =   360
      TabIndex        =   17
      Top             =   3840
      Width           =   4215
   End
   Begin VB.Label Label1 
      Caption         =   "Variable A"
      Height          =   255
      Left            =   120
      TabIndex        =   16
      Top             =   720
      Width           =   735
   End
   Begin VB.Label Label5 
      Caption         =   "Variable B"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   1560
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Message"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   2640
      Width           =   735
   End
End
Attribute VB_Name = "FrmSwitch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private ExchangeOn As Boolean

Private Const CMtoMS = 5 'arbitrary variable numbers
Private Const MStoCM = 6

Private Sub CheckPolling_Click()
If CheckPolling.Value = 1 Then
ExchangeOn = True
Else
ExchangeOn = False
End If
End Sub

Private Sub CommandExchange_Click(Direction As Integer)
Dim Content As Integer
    VB.Screen.MousePointer = vbHourglass

Select Case Direction
Case Spirit 'From MS to CM
    'Contact (RCX)
    Content = fMain.Spirit1.Poll(variable, MStoCM)
    TextVar2(RCX).Text = Content
    'Contact (Spirit)
    Me.SpiritSecundary.SetVar MStoCM, Number, Content
    TextVar2(Spirit).Text = Content
Case RCX 'From CM to MS
    'Contact (Spirit)
    Content = Me.SpiritSecundary.Poll(variable, CMtoMS)
    TextVar1(Spirit).Text = Content
    'Contact (RCX)
    fMain.Spirit1.SetVar CMtoMS, Number, Content
    TextVar1(RCX).Text = Content
Case 2 'inside Spirit
    'Contact (Spirit)
    Content = Me.SpiritSecundary.Poll(variable, MStoCM)
    TextVar1(Spirit).Text = Content
    Me.SpiritSecundary.SetVar CMtoMS, Number, Content
    TextVar2(Spirit).Text = Content
Case 3 'inside RCX
    'Contact (RCX)
    Content = fMain.Spirit1.Poll(variable, CMtoMS)
    TextVar2(RCX).Text = Content
    fMain.Spirit1.SetVar MStoCM, Number, Content
    TextVar1(RCX).Text = Content
Case Else
End Select
    VB.Screen.MousePointer = vbDefault

End Sub

Private Sub CommandGetMessage_Click()
Contact Spirit
fSwitch.TextMessage(Spirit).Text = Me.SpiritSecundary.Poll(MESSAGE, 0)
Contact RCX
fSwitch.TextMessage(RCX).Text = fMain.Spirit1.Poll(MESSAGE, 0)
End Sub

Private Sub Form_Load()

    Set fMain = New frmMain
    Load fMain


'Contact (Spirit)
'fMain.Spirit1.SetVar CMtoMS, Number, 12
'fMain.Spirit1.SetVar MStoCM, Number, 13
'fSwitch.TextVar1(Spirit).Text = 12
'fSwitch.TextVar2(Spirit).Text = 13

'Contact (RCX)
'fMain.Spirit1.SetVar CMtoMS, Number, 14
'fMain.Spirit1.SetVar MStoCM, Number, 15
'fSwitch.TextVar1(RCX).Text = 14
'fSwitch.TextVar2(RCX).Text = 15

ExchangeOn = False
fSwitch.CheckPolling.Value = 0

Contact (RCX)
Contact (Spirit)

End Sub

Private Sub Contact(SystemType As PBRICKOPTIONS)
    'Set fMain = New frmMain
    'Load fMain
VB.Screen.MousePointer = vbHourglass

If SystemType = RCX Then
With fMain.Spirit1
    MsgBox ("MS benaderen")
    .PBrick = RCX
    .ComPortNo = COM1
    .LinkType = InfraRed
    .InitComm
End With
Else 'SystemType = Spirit
With Me.SpiritSecundary
    MsgBox ("CM benaderen")
    .PBrick = Spirit
    .ComPortNo = COM2
    .LinkType = Radio
    .InitComm
    MsgBox (.UnlockFirmware("Do you byte, when I knock?"))
    .UnlockPBrick
End With
End If
VB.Screen.MousePointer = vbDefault

End Sub


Private Sub TextVar1_Change(SystemType As Integer)
    'Contact (SystemType)
    Select Case SystemType
    Case RCX
        fMain.Spirit1.SetVar CMtoMS, Number, Val(TextVar1(SystemType).Text)
    Case Spirit
        Me.SpiritSecundary.SetVar CMtoMS, Number, Val(TextVar1(SystemType).Text)
    End Select
End Sub
Private Sub TextVar2_Change(SystemType As Integer)
    'Contact (SystemType)
    Select Case SystemType
    Case RCX
        fMain.Spirit1.SetVar MStoCM, Number, Val(TextVar2(SystemType).Text)
    Case Spirit
        Me.SpiritSecundary.SetVar MStoCM, Number, Val(TextVar2(SystemType).Text)
    End Select
End Sub


Private Sub TimerExchange_Timer()
    'copy var CMToMS from Spirit to RCX
    Dim Content1 As Integer
    Dim Content2 As Integer
    If ExchangeOn Then
    
        'Contact (Spirit)
        Content1 = Me.SpiritSecundary.Poll(variable, CMtoMS)
        TextVar1(Spirit).Text = Content1
        Contact (RCX)
        fMain.Spirit1.SetVar CMtoMS, Number, Content1
        Content2 = fMain.Spirit1.Poll(variable, MStoCM) 'kan weg
        TextVar2(RCX).Text = Content2
        'Contact (Spirit)
        Me.SpiritSecundary.SetVar MStoCM, Number, Content2
        TextVar2(Spirit).Text = Content2
    End If
End Sub
