VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "ClassPrograms"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Enum SpiritValue
    VARIABLE = 0
    TIMER = 1
    NUMBER = 2
    OUTPUTPORT = 3
    RANDOM = 4
    SENSOR = 9
    SENSOR_RAW = 12
    MINUTES = 14
    INMESSAGE = 15
End Enum

Public Enum SpiritOperator
    GREATER_THAN = 0
    LESS_THAN = 1
    EQUAL_TO = 2
    NOT_EQUAL_TO = 3
End Enum


'Private Const MOTOR_A = "0" 'zijn al publiek bekend
'Private Const MOTOR_B = "1"
'Private Const MOTOR_C = "2"
'Public constants cannot be declared in a form or class module.


'ALGEMEEN STRAMIEN
Public Sub firstprogram()
fMain.Spirit1.SelectPrgm (3)
fMain.Spirit1.BeginOfSub (3)
'code for subroutine 3
fMain.Spirit1.EndOfSub
'other subroutines
fMain.Spirit1.BeginOfSub (6)
'code for subroutine 6
fMain.Spirit1.EndOfSub
fMain.Spirit1.BeginOfTask (1)
'code for task 1
fMain.Spirit1.EndOfTask
'other tasks
fMain.Spirit1.BeginOfTask (0)
'code for task 0, start other tasks from here
fMain.Spirit1.EndOfTask

' NESTED CONTROL LOOPS wel mogelijk!
'one transmission for each endtask/sub
'wait a sec after each endtask/sub

End Sub

Private Sub LEGOprogram1()
'constant power
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .PlaySystemSound 1
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .On (MOTOR_A & MOTOR_C)
    .EndWhile
    'Without the while-loop, the motors will stay on after the program is stopped!!
.EndOfTask
End With
End Sub

Private Sub LEGOprogram2()
'two touch sensors stop a motor each
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 0, EQUAL_TO, NUMBER, 0
            .On (MOTOR_A)
        .Else
            .Off (MOTOR_A)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 2
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 2, EQUAL_TO, NUMBER, 0
            .On (MOTOR_C)
        .Else
            .Off (MOTOR_C)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
.EndOfTask
End With
End Sub

    'Dit blijkt niet als eternal loop te werken:
    '.While NUMBER, 1, GREATER_THAN, NUMBER, 0
    'Loop counts down by itself, even Loop NUMBER 1
    
    'Dit lijkt soms wel en soms niet als eternal te werken:
    '.Loop NUMBER, 1 'eternal loop





Private Sub Testprogram1()
'musical
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .PlayTone 400, 200
    .PlayTone 800, 200
    .PlayTone 1600, 200
    .PlayTone 3200, 200
.EndOfTask
End With
End Sub

Private Sub Testprogram2()
'count seven tones
With fMain.Spirit1
.DeleteAllTasks
    .BeginOfTask (0)
    .SetVar 3, NUMBER, 7 'variabele 3 waarde 7
    .Loop VARIABLE, 3 'zolang var 3 groter dan nul, telt vanzelf af!
        .PlaySystemSound (4)
        .Wait NUMBER, 100 'wait 1 sec
        .PlaySystemSound (0)
    .EndLoop
    .PlaySystemSound (1)
    .EndOfTask
End With
End Sub

Private Sub Testprogram3()
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .PlayTone 400, 1000
.EndOfTask
Wait 1
.BeginOfTask 2
    .PlaySystemSound (2)
.EndOfTask
Wait 1
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
.EndOfTask
End With
End Sub



Private Sub Testprogram4()
'eternal siren
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask (0)
    .SetVar 3, NUMBER, 7 'variabele 3 waarde 7
    .While VARIABLE, 3, GREATER_THAN, NUMBER, 0 'eternal loop
        .PlayTone 440, 10
        .Wait NUMBER, 10
        .PlayTone 840, 10
        .Wait NUMBER, 10
    .EndWhile
    .PlaySystemSound (1)
.EndOfTask
End With
End Sub

Private Sub Testprogram5()
'Respond to sensor
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .While SENSOR, 0, EQUAL_TO, NUMBER, 0
        .PlayTone 400, 1
    .EndWhile
    .PlayTone 800, 10
.EndOfTask
End With
End Sub

Private Sub Testprogram6()
'Three sensors control three motors
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 0, EQUAL_TO, NUMBER, 1
            .On (MOTOR_A)
        .Else
            .Off (MOTOR_A)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 2
    .SetVar 2, NUMBER, 1 'variable 2 gets value 1
    .While VARIABLE, 2, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 1, EQUAL_TO, NUMBER, 1
            .On (MOTOR_B)
        .Else
            .Off (MOTOR_B)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 3
    .SetVar 3, NUMBER, 1 'variable 3 gets value 1
    .While VARIABLE, 3, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 2, EQUAL_TO, NUMBER, 1
            .On (MOTOR_C)
        .Else
            .Off (MOTOR_C)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
    .StartTask 3
.EndOfTask
End With
End Sub

Private Sub Testprogram7()
'random tones
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .SetVar 2, RANDOM, 3 'random integers van 0 tot n
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 0
            .PlayTone 400, 1
        .EndIf
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 1
            .PlayTone 800, 1
        .EndIf
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 2
            .PlayTone 1600, 1
        .EndIf
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 3
            .PlayTone 3200, 1
        .EndIf
        '.Wait NUMBER, 10
    .EndWhile
.EndOfTask
End With
End Sub


Private Sub Testprogram8()
'Random drift of motors
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If RANDOM, 1, GREATER_THAN, NUMBER, 0
            .SetFwd MOTOR_A
        .Else
            .SetRwd MOTOR_A
        .EndIf
        .SetPower MOTOR_A, NUMBER, 5
        .On MOTOR_A
        .Wait NUMBER, 100
        .Off MOTOR_A
        .Wait NUMBER, 100
    .EndWhile
.EndOfTask
End With
End Sub



Private Sub Wait(Seconds As Integer)
Dim Begin As Date
Begin = Now
Do Until DateDiff("s", Begin, Now) = Seconds
'wait
Loop
End Sub


