VERSION 5.00
Begin VB.Form frmDownload 
   Caption         =   "Download"
   ClientHeight    =   4875
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7140
   LinkTopic       =   "Form1"
   ScaleHeight     =   4875
   ScaleWidth      =   7140
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CommandOpen 
      Caption         =   "<"
      Height          =   255
      Left            =   1560
      TabIndex        =   14
      Top             =   2880
      Width           =   255
   End
   Begin VB.TextBox TextFileToInterprete 
      Alignment       =   1  'Right Justify
      Height          =   285
      Left            =   120
      Locked          =   -1  'True
      TabIndex        =   13
      Text            =   "Text1"
      Top             =   2880
      Width           =   1335
   End
   Begin VB.ComboBox ComboFile 
      Height          =   315
      Left            =   2640
      TabIndex        =   12
      Text            =   "Program"
      Top             =   4320
      Visible         =   0   'False
      Width           =   1335
   End
   Begin VB.CommandButton CommandInterprete 
      Caption         =   "Interprete"
      Height          =   375
      Left            =   120
      TabIndex        =   9
      Top             =   3240
      Width           =   1335
   End
   Begin VB.CommandButton CommandClear 
      Caption         =   "Clear log"
      Height          =   255
      Left            =   5880
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox TextLog 
      Height          =   3735
      Left            =   1920
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      Text            =   "FormDownload.frx":0000
      Top             =   360
      Width           =   5175
   End
   Begin VB.CommandButton CommandDownload 
      Caption         =   "Download"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   1680
      Width           =   1335
   End
   Begin VB.ComboBox ComboSlot 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Text            =   "Slot"
      Top             =   360
      Width           =   1335
   End
   Begin VB.CommandButton CommandOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   6000
      TabIndex        =   2
      Top             =   4320
      Width           =   735
   End
   Begin VB.ComboBox ComboProgram 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Text            =   "Program"
      Top             =   1320
      Width           =   1335
   End
   Begin VB.CommandButton CommandFirmware 
      Caption         =   "Download firmware"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   4320
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Download from text file"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   2640
      Width           =   1815
   End
   Begin VB.Line Line3 
      X1              =   120
      X2              =   1800
      Y1              =   720
      Y2              =   720
   End
   Begin VB.Label Label4 
      Caption         =   "Download from library"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   1080
      Width           =   1575
   End
   Begin VB.Line Line2 
      X1              =   120
      X2              =   1800
      Y1              =   2520
      Y2              =   2520
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   7080
      Y1              =   4200
      Y2              =   4200
   End
   Begin VB.Label Label3 
      Caption         =   "Log"
      Height          =   255
      Left            =   1920
      TabIndex        =   8
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label1 
      Caption         =   "Program slot"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "FrmDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private ProgramSelected As Integer '1 to n
Private FileSelected As Integer

Private Sub ComboFile_Click()
FileSelected = ComboFile.ListIndex + 1
End Sub

Private Sub ComboProgram_Click()
ProgramSelected = ComboProgram.ListIndex + 1
End Sub



Private Sub CommandClear_Click()
TextLog.Text = Time & " Cleared"
End Sub

Private Sub CommandDownload_Click()
VB.Screen.MousePointer = vbHourglass
TextLog.Text = TextLog.Text & vbCrLf & "___" & _
    vbCrLf & Time & " Load program " & ProgramSelected & _
    " into slot " & ProgSlot + 1
ModulePrograms.LoadProgram (ProgramSelected)
VB.Screen.MousePointer = vbDefault
End Sub

Private Sub CommandInterprete_Click()
VB.Screen.MousePointer = vbHourglass
TextLog.Text = TextLog.Text & vbCrLf & "___" & _
    vbCrLf & Time & " Interprete file " & FileToInterprete & _
    " with immediate download into slot " & ProgSlot + 1
ModuleInterpreter.InterpreteFile _
    DirToInterprete & "/" & FileToInterprete
VB.Screen.MousePointer = vbDefault
End Sub

Private Sub CommandOK_Click()
        Unload Me
End Sub

Private Sub CommandOpen_Click()
    VB.Screen.MousePointer = vbHourglass
    Dim fOpen As New frmOpen
    Load fOpen
    VB.Screen.MousePointer = vbDefault
    fOpen.Show vbModal
    TextFileToInterprete.Text = FileToInterprete
End Sub

Private Sub Form_Load()
   'show current values
Dim NumberOfPrograms As Integer
Dim NumberOfFiles As Integer
Dim i As Integer

NumberOfPrograms = 9
NumberOfFiles = 4
ProgramSelected = 1
FileSelected = 1
TextFileToInterprete.Text = FileToInterprete

For i = 1 To NumberOfPrograms
    ComboProgram.AddItem "Program " & i
Next
ComboProgram.ListIndex = ProgramSelected - 1
For i = 1 To NumberOfFiles
    ComboFile.AddItem "myprog" & i & ".txt"
Next
'dit kan weg
ComboFile.ListIndex = FileSelected - 1
For i = 1 To 5 'number of slots
    ComboSlot.AddItem i
Next
End Sub

Private Sub ComboSlot_Click()
ProgSlot = ComboSlot.ListIndex '0 to 4
fMain.Spirit1.SelectPrgm ProgSlot
End Sub

Private Sub CommandFirmware_Click()
Dim FirmFile As String
'MsgBox ("tijdelijk kortgesloten vanwege licensie")
'fmain.dlgOpenFirmware.ShowOpen
'firmfile = fmain.dlgOpenFirmware.filename
FirmFile = "Firm0309.lgo"
'If Not fmain.dlgOpenFirmware.Action Then
    fMain.Sending (True)
    fMain.Spirit1.DownloadFirmware FirmFile
    fMain.Sending (False)
'End If
End Sub



Private Sub TextLog_Change()
'always scroll down
TextLog.SelStart = Len(TextLog.Text)
End Sub


Private Sub WaitDownloadDone()
'NOT USED, doesn't work
Dim Begin As Date
Dim MaxWait As Integer
Begin = Now
MaxWait = 5 'seconds
'DownloadDone = False
'Do Until DownloadDone 'Triggered by event Spirit1_DownloadDone
'    If DateDiff("s", Begin, Now) = MaxWait Then
'        MsgBox ("Download did not succeed within " & MaxWait & " seconds." & Chr(10) & "Download aborted.")
'    Exit Do
'    End If
'Loop
End Sub


