VERSION 5.00
Begin VB.Form frmDownload 
   Caption         =   "Download"
   ClientHeight    =   4875
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6795
   LinkTopic       =   "Form1"
   ScaleHeight     =   4875
   ScaleWidth      =   6795
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CommandClear 
      Caption         =   "Clear log"
      Height          =   255
      Left            =   5520
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox TextLog 
      Height          =   3735
      Left            =   1560
      Locked          =   -1  'True
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      Top             =   360
      Width           =   5175
   End
   Begin VB.CommandButton CommandDownload 
      Caption         =   "Download"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   1560
      Width           =   1335
   End
   Begin VB.ComboBox ComboSlot 
      Height          =   315
      Left            =   120
      TabIndex        =   3
      Text            =   "Slot"
      Top             =   360
      Width           =   1335
   End
   Begin VB.CommandButton CommandOK 
      Caption         =   "OK"
      Default         =   -1  'True
      Height          =   375
      Left            =   6000
      TabIndex        =   2
      Top             =   4320
      Width           =   735
   End
   Begin VB.ComboBox ComboProgram 
      Height          =   315
      Left            =   120
      TabIndex        =   1
      Text            =   "Program"
      Top             =   1080
      Width           =   1335
   End
   Begin VB.CommandButton CommandFirmware 
      Caption         =   "Download firmware"
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   4320
      Width           =   1575
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   6720
      Y1              =   4200
      Y2              =   4200
   End
   Begin VB.Label Label3 
      Caption         =   "Log"
      Height          =   255
      Left            =   1560
      TabIndex        =   9
      Top             =   120
      Width           =   735
   End
   Begin VB.Label Label2 
      Caption         =   "Library entry"
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   840
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Program slot"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   120
      Width           =   975
   End
End
Attribute VB_Name = "FrmDownload"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private ProgramSelected As Integer '1 to n
Private Const GREATER_THAN = 0
Private Const LESS_THAN = 1
Private Const EQUAL_TO = 2
Private Const NOT_EQUAL_TO = 3
Private Const VARIABLE = 0
Private Const TIMER = 1
Private Const NUMBER = 2
Private Const OUTPUTPORT = 3
Private Const RANDOM = 4
Private Const SENSOR = 9
Private Const SENSOR_RAW = 12
Private Const MINUTES = 14
Private Const Message = 15
'Private Const MOTOR_A = "0" 'zijn al publiek bekend
'Private Const MOTOR_B = "1"
'Private Const MOTOR_C = "2"
'Public constants cannot be declared in a form or class module.




Private Sub ComboProgram_Click()
'Sending (True)
ProgramSelected = ComboProgram.ListIndex + 1
'Sending (False)
End Sub



Private Sub CommandClear_Click()
TextLog.Text = Time & " Cleared"
End Sub

Private Sub CommandDownload_Click()
LoadProgram (ProgramSelected)
End Sub

Private Sub CommandOK_Click()
        Unload Me
End Sub

Private Sub Form_Load()
   'show current values
Dim Number_of_programs As Integer
Dim i As Integer
Number_of_programs = 8
For i = 1 To Number_of_programs
    ComboProgram.AddItem "Program " & i
Next
ProgramSelected = 1
ComboProgram.ListIndex = ProgramSelected - 1
For i = 1 To 5 'number of slots
    ComboSlot.AddItem i
Next
ComboSlot.ListIndex = ProgSlot '0 to 4
End Sub

Private Sub ComboSlot_Click()
ProgSlot = ComboSlot.ListIndex '0 to 4
fMain.Spirit1.SelectPrgm ProgSlot
End Sub

Private Sub CommandFirmware_Click()
Dim FirmFile As String
MsgBox ("tijdelijk kortgesloten vanwege licensie")
'fmain.dlgOpenFirmware.ShowOpen
'firmfile = fmain.dlgOpenFirmware.filename
FirmFile = "Firm0309.lgo"
'If Not fmain.dlgOpenFirmware.Action Then
    fMain.Sending (True)
    fMain.Spirit1.DownloadFirmware FirmFile
    fMain.Sending (False)
'End If
End Sub



'PROGRAMMA's

Public Sub LoadProgram(Prognr As Integer)
TextLog.Text = TextLog.Text & vbCrLf & "___" & vbCrLf & Time & " Load program " & Prognr & " into slot " & ProgSlot + 1
fMain.Spirit1.SelectPrgm ProgSlot
Select Case Prognr
    Case 1
    LEGOprogram1
    Case 2
    LEGOprogram2
    Case 3
    Testprogram3
    Case 4
    Testprogram4
    Case 5
    Testprogram5
    Case 6
    Testprogram6
    Case 7
    Testprogram7
    Case 8
    Testprogram8

Case Else
MsgBox ("Doesn't exist")
End Select
End Sub


'ALGEMEEN STRAMIEN
Public Sub firstprogram()
fMain.Spirit1.SelectPrgm (3)
fMain.Spirit1.BeginOfSub (3)
'code for subroutine 3
fMain.Spirit1.EndOfSub
'other subroutines
fMain.Spirit1.BeginOfSub (6)
'code for subroutine 6
fMain.Spirit1.EndOfSub
fMain.Spirit1.BeginOfTask (1)
'code for task 1
fMain.Spirit1.EndOfTask
'other tasks
fMain.Spirit1.BeginOfTask (0)
'code for task 0, start other tasks from here
fMain.Spirit1.EndOfTask

' NESTED CONTROL LOOPS wel mogelijk!
'one transmission for each endtask/sub
'wait a sec after each endtask/sub

End Sub

Private Sub LEGOprogram1()
'constant power
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .PlaySystemSound 1
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .On (MOTOR_A & MOTOR_C)
    .EndWhile
    'Without the while-loop, the motors will stay on after the program is stopped!!
.EndOfTask
End With
End Sub

Private Sub LEGOprogram2()
'two touch sensors stop a motor each
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 0, EQUAL_TO, NUMBER, 0
            .On (MOTOR_A)
        .Else
            .Off (MOTOR_A)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 2
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 2, EQUAL_TO, NUMBER, 0
            .On (MOTOR_C)
        .Else
            .Off (MOTOR_C)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
.EndOfTask
End With
End Sub

    'Dit blijkt niet als eternal loop te werken:
    '.While NUMBER, 1, GREATER_THAN, NUMBER, 0
    'Loop counts down by itself, even Loop NUMBER 1
    
    'Dit lijkt soms wel en soms niet als eternal te werken:
    '.Loop NUMBER, 1 'eternal loop





Private Sub Testprogram1()
'musical
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .PlayTone 400, 200
    .PlayTone 800, 200
    .PlayTone 1600, 200
    .PlayTone 3200, 200
.EndOfTask
End With
End Sub

Private Sub Testprogram2()
'count seven tones
With fMain.Spirit1
.DeleteAllTasks
    .BeginOfTask (0)
    .SetVar 3, NUMBER, 7 'variabele 3 waarde 7
    .Loop VARIABLE, 3 'zolang var 3 groter dan nul, telt vanzelf af!
        .PlaySystemSound (4)
        .Wait NUMBER, 100 'wait 1 sec
        .PlaySystemSound (0)
    .EndLoop
    .PlaySystemSound (1)
    .EndOfTask
End With
End Sub

Private Sub Testprogram3()
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .PlayTone 400, 1000
.EndOfTask
Wait 1
.BeginOfTask 2
    .PlaySystemSound (2)
.EndOfTask
Wait 1
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
.EndOfTask
End With
End Sub



Private Sub Testprogram4()
'eternal siren
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask (0)
    .SetVar 3, NUMBER, 7 'variabele 3 waarde 7
    .While VARIABLE, 3, GREATER_THAN, NUMBER, 0 'eternal loop
        .PlayTone 440, 10
        .Wait NUMBER, 10
        .PlayTone 840, 10
        .Wait NUMBER, 10
    .EndWhile
    .PlaySystemSound (1)
.EndOfTask
End With
End Sub

Private Sub Testprogram5()
'Respond to sensor
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .While SENSOR, 0, EQUAL_TO, NUMBER, 0
        .PlayTone 400, 1
    .EndWhile
    .PlayTone 800, 10
.EndOfTask
End With
End Sub

Private Sub Testprogram6()
'Three sensors control three motors
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 1
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 0, EQUAL_TO, NUMBER, 1
            .On (MOTOR_A)
        .Else
            .Off (MOTOR_A)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 2
    .SetVar 2, NUMBER, 1 'variable 2 gets value 1
    .While VARIABLE, 2, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 1, EQUAL_TO, NUMBER, 1
            .On (MOTOR_B)
        .Else
            .Off (MOTOR_B)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 3
    .SetVar 3, NUMBER, 1 'variable 3 gets value 1
    .While VARIABLE, 3, GREATER_THAN, NUMBER, 0 'eternal loop
        .If SENSOR, 2, EQUAL_TO, NUMBER, 1
            .On (MOTOR_C)
        .Else
            .Off (MOTOR_C)
        .EndIf
    .EndWhile
.EndOfTask
Wait 2
.BeginOfTask 0
    .StartTask 1
    .StartTask 2
    .StartTask 3
.EndOfTask
End With
End Sub

Private Sub Testprogram7()
'random tones
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .SetVar 2, RANDOM, 3 'random integers van 0 tot n
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 0
            .PlayTone 400, 1
        .EndIf
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 1
            .PlayTone 800, 1
        .EndIf
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 2
            .PlayTone 1600, 1
        .EndIf
        .If VARIABLE, 2, EQUAL_TO, NUMBER, 3
            .PlayTone 3200, 1
        .EndIf
        '.Wait NUMBER, 10
    .EndWhile
.EndOfTask
End With
End Sub


Private Sub Testprogram8()
'Random drift of motors
With fMain.Spirit1
.DeleteAllTasks
.BeginOfTask 0
    .SetVar 1, NUMBER, 1 'variable 1 gets value 1
    .While VARIABLE, 1, GREATER_THAN, NUMBER, 0 'eternal loop
        .If RANDOM, 1, GREATER_THAN, NUMBER, 0
            .SetFwd MOTOR_A
        .Else
            .SetRwd MOTOR_A
        .EndIf
        .SetPower MOTOR_A, NUMBER, 5
        .On MOTOR_A
        .Wait NUMBER, 100
        .Off MOTOR_A
        .Wait NUMBER, 100
    .EndWhile
.EndOfTask
End With
End Sub



Private Sub Wait(Seconds As Integer)
'tijdelijk:
'Exit Sub
Dim Begin As Date
Begin = Now
Do Until DateDiff("s", Begin, Now) = Seconds
'wacht
Loop
End Sub

Private Sub WaitDownloadDone()
'NOT USED, doesn't work
Dim Begin As Date
Begin = Now
MaxWait = 5 'seconds
DownloadDone = False
Do Until DownloadDone 'Triggered by event Spirit1_DownloadDone
    If DateDiff("s", Begin, Now) = MaxWait Then
        MsgBox ("Download did not succeed within " & MaxWait & " seconds." & Chr(10) & "Download aborted.")
    Exit Do
    End If
Loop
End Sub

Private Sub TextLog_Change()
'always scroll down
TextLog.SelStart = Len(TextLog.Text)
End Sub
