VERSION 5.00
Begin VB.Form FrmInterprete 
   Caption         =   "Interprete"
   ClientHeight    =   3195
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3195
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton CommandInterprete 
      Caption         =   "Interprete Myprog.txt"
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   360
      Width           =   1935
   End
End
Attribute VB_Name = "FrmInterprete"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'Valid demarcation characters in syntax
Const SYNTAX_COMMAND = "'( "
Const SYNTAX_ARGUMENT = ",) "
'Examples:
'       PlayTone 400 500
'       PlayTone 400,500
'       PlayTone(400,500)
'       'Comment
'Commands are case insensitive
'space *plus* comma not allowed!


Private Sub CommandInterprete_Click()
    Set fDownload = New FrmDownload
    Load fDownload
    fDownload.Show


With frmMain.Spirit1
.ComPortNo = COM2
.InitComm
InterpreteFile
.CloseComm
End With
End Sub

Private Sub InterpreteFile()
Dim MyChar As String * 1
Dim Line As String
Dim LineCount As Integer
Line = "": MyChar = "": LineCount = 0
Open "myprog.txt" For Input As #1 ' Open file.
Do While Not EOF(1) ' Loop until end of file.
    MyChar = Input(1, #1)   ' Get one character.
    If MyChar = vbCr Then 'end of line
        LineCount = LineCount + 1
        InterpreteLine Line, LineCount
        MyChar = Input(1, #1) 'read extra vbLf
        Line = ""
    Else
        Line = Line & MyChar
    End If
Loop
Close #1    ' Close file.
End Sub
'make sure to end txt file with at least one Enter!
'or last line will not be processed

Private Sub InterpreteLine(Line As String, LineCount As Integer)
Dim Result As String
'Dim Command As String
        Debug.Print Line  ' Print to Debug window.
Line = Trim(Line) 'trim spaces
Line = LCase(Line) 'all lowercase
        Debug.Print Line  ' Print to Debug window.

Select Case CommandOf(Line)
Case ""
    Result = "Comment or empty line"
Case "aboutbox"
    frmMain.Spirit1.AboutBox
    
Case "beginofsub"
    frmMain.Spirit1.BeginOfSub NextArgument(Line)
Case "endofsub"
    frmMain.Spirit1.EndOfSub
    PauseDownload 1
Case "gosub"
    frmMain.Spirit1.GoSub NextArgument(Line)
Case "deleteallsubs"
    Result = "I must reset"
    frmMain.Spirit1.DeleteAllSubs
Case "beginoftask"
    frmMain.Spirit1.BeginOfTask NextArgument(Line)
Case "endoftask"
    frmMain.Spirit1.EndOfTask
    PauseDownload 1
Case "starttask"
    frmMain.Spirit1.StartTask NextArgument(Line)
Case "stoptask"
    frmMain.Spirit1.StopTask NextArgument(Line)
Case "stopalltasks"
    frmMain.Spirit1.StopAllTasks
Case "deletealltasks"
    Result = "I must reset"
    frmMain.Spirit1.DeleteAllTasks

Case "if"
    frmMain.Spirit1.If _
        ValueSource(NextArgument(Line)), NextArgument(Line), _
        NextArgument(Line), _
        ValueSource(NextArgument(Line)), NextArgument(Line)
Case "else"
    frmMain.Spirit1.Else
Case "endif"
    frmMain.Spirit1.EndIf
Case "loop"
    frmMain.Spirit1.Loop _
        ValueSource(NextArgument(Line)), NextArgument(Line)
Case "endloop"
    frmMain.Spirit1.EndLoop
Case "while"
    frmMain.Spirit1.While _
        ValueSource(NextArgument(Line)), NextArgument(Line), _
        NextArgument(Line), _
        ValueSource(NextArgument(Line)), NextArgument(Line)

Case "endwhile"
    frmMain.Spirit1.EndWhile
Case "wait"
    frmMain.Spirit1.Wait _
    ValueSource(NextArgument(Line)), NextArgument(Line)


Case "on"
    frmMain.Spirit1.On NextArgument(Line)
Case "off"
    frmMain.Spirit1.Off NextArgument(Line)
Case "setpower"
    frmMain.Spirit1.SetPower NextArgument(Line), _
    ValueSource(NextArgument(Line)), NextArgument(Line)
Case "setfwd"
    frmMain.Spirit1.SetFwd NextArgument(Line)
Case "setrwd"
    frmMain.Spirit1.SetRwd NextArgument(Line)

Case "setsensortype"
    frmMain.Spirit1.SetSensorType NextArgument(Line), NextArgument(Line)
Case "setsensormode"
    frmMain.Spirit1.SetSensorMode NextArgument(Line), NextArgument(Line), NextArgument(Line)
Case "poll"
    frmMain.Spirit1.Poll ValueSource(NextArgument(Line)), NextArgument(Line)
Case "sendpbmessage"
    frmMain.Spirit1.SendPBMessage ValueSource(NextArgument(Line)), NextArgument(Line)


Case "playsystemsound"
    Result = "I must play systemsound no. " & NextArgument(Line)
    frmMain.Spirit1.PlaySystemSound NextArgument(Line)
Case "playtone"
    Result = "I must play tone " & NextArgument(Line) _
    & " for " & NextArgument(Line) & " msecs."
    frmMain.Spirit1.PlayTone Val(NextArgument(Line)), Val(NextArgument(Line))
Case "setvar"
    Result = "I must set var " & NextArgument(Line) _
    & " with " & ValueSource(NextArgument(Line)) & " of " & NextArgument(Line)
    frmMain.Spirit1.SetVar NextArgument(Line), ValueSource(NextArgument(Line)), NextArgument(Line)
Case Else
    Result = "Command not recognized"
End Select
Debug.Print "Line " & LineCount & ": " & Result
End Sub

Private Function CommandOf(Line As String) As String
'This is funky programming!
CutString Line, SYNTAX_COMMAND, CommandOf, Line
End Function

Private Function NextArgument(Arguments As String) As String
'More funky programming
CutString Arguments, SYNTAX_ARGUMENT, NextArgument, Arguments
End Function


Private Function LookFor(Line As String, Match As String) As Integer
LookFor = InStr(1, Line, Match, 1) 'textual compare, case insensitive
End Function


Private Function CutString(Phrase As String, _
        Cut As String, InFront As String, Behind As String) _
        As Boolean
        'splits string in two parts, cut may be a string _
        of MULTIPLE possible demarcation characters
    Dim cutpos As Integer
    Dim Finished As Boolean
    Dim Cycle As Integer
    Dim CutChar As String * 1
    Cycle = 1
    For Cycle = 1 To Len(Cut)
        CutChar = Mid(Cut, Cycle, 1) 'cycles through Cut list

        cutpos = LookFor(Phrase, CutChar) 'look for this Cut char
        If cutpos > 0 Then  'Cut char found
            If cutpos = 1 Then  'Cut Char is first char of Phrase
                InFront = ""
                Behind = Mid(Phrase, cutpos + 1)
            ElseIf cutpos = Len(Phrase) Then 'Cut Char is last char of Phrase
                InFront = Left(Phrase, cutpos - 1)
                Behind = ""
            Else 'Cut Char is somewhere else along Phrase
                InFront = Left(Phrase, cutpos - 1)
                Behind = Mid(Phrase, cutpos + 1)
            End If
            CutString = True

            Exit Function   'EXIT HERE
        End If
        
    Next
    'if no Cut character found
    InFront = Phrase
    Behind = ""
    CutString = False
End Function

Function ValueSource(ConstName As String)
Debug.Print (ConstName)
    ValueSource = Switch( _
    ConstName = "variable", 0, _
    ConstName = "timer", 1, _
    ConstName = "number", 2, _
    ConstName = "ouputport", 3, _
    ConstName = "random", 4, _
    ConstName = "sensor", 9, _
    ConstName = "sensor_raw", 12, _
    ConstName = "minutes", 14, _
    ConstName = "inmessage", 15, _
    True, ConstName) 'else return input
End Function
