Attribute VB_Name = "ModuleMain"
Option Explicit

Public fMain As frmMain
Public fSplash As frmSplash
Public fOptions As frmOptions
Public fDownload As FrmDownload
Public fSwitch As FrmSwitch

Public ComPort As Integer
Public TransMode As Integer
Public BrickType As Integer
Public ProgSlot As Integer
Public logboek As String
Public AllHold As Boolean
Public FileToInterprete As String
Public DirToInterprete As String

Public Enum MotorName
    motor_a = 0
    motor_b = 1
    motor_c = 2
End Enum

Public Enum DirectionButton
    LEFT_ = 0   'name LEFT would interfere with window property
    FRONT = 1
    Right = 2
    BACK = 3
    ACTION_1 = 4 'auxiliary direction buttons
    ACTION_2 = 5
End Enum

Public Type Motorsetting
    Ison As Boolean
    Forward As Boolean
    Power As Integer
End Type

Public Type MotorsettingSet 'for three motors
    OutPort(motor_a To motor_c) As Motorsetting
End Type

Public Type CombicontrolSetting 'motorsettings for each 'direction button'
    Button(LEFT_ To ACTION_2) As MotorsettingSet
End Type

'example: setting.button(LEFT_).outport(MOTOR_A).Ison = true

Sub Main()
    
    
    'hourglass cursor
    VB.Screen.MousePointer = vbHourglass
    
    'show splash screen
    Set fSplash = New frmSplash
    fSplash.Show
    fSplash.Refresh
    
    'global settings
    ComPort = COM1 'COM1
    TransMode = InfraRed 'Radio
    BrickType = RCX 'Spirit 'RCX
    ProgSlot = 2 '0 to 4, shows as 1 to 5 on RCX
    AllHold = False 'True
    FileToInterprete = "myprog1.txt"
    DirToInterprete = CurDir

    'fmain.Spirit1.InitComm
    'If Not fmain.Spirit1.PBAliveOrNot Then
    '    MsgBox ("Programmable brick does not respond." & Chr(10) & "All transmissions on hold." & Chr(10) & "Please fill in options form when you're ready")
    '    AllHold = True
    'Else
    '    AllHold = False
    'End If
    
    'Load forms
    Set fMain = New frmMain
    Load fMain
    Set fOptions = New frmOptions
    Load fOptions
    'Set fLog = New frmLog
    'Load fLog

    
'temporary escape
    'frmTachotest.Show
    'Exit Sub

    
    'show forms
    'fLog.Show
    fMain.Show
    fOptions.Show
    
    'hide splash, cursor normal
    Unload fSplash
    VB.Screen.MousePointer = vbDefault
    
End Sub



